/*******************************************************
 *  Unit test for the String class
 *
 * test conversion operations
 ******************************************************
 *
 */

#include "String.h"
#include <assert.h>

int main()
{

   // Construct a string from a number

   String s1(12);

   std::cout << s1 << " is contructed from the number 12\n";
   assert(s1 == "12");

   String s2(2.32);

   std::cout << s2 << " is contructed from the number 2.32\n";
   assert(s2 == "2.320");

   int    n;
   double f;

   String s3("42");
   n = int(s3);
   std::cout << "String " << s3 << " converts into number " << n << "\n";
   assert(n == 42);

   String s4("3.1415");
   f = double(s4);
   std::cout << "String " << s4 << " converts into number " << f << "\n";
   assert(f == 3.1415);

   int     k;
   double  x;

   String s5("not a number");
   k = int(s5);
   std::cout << "String " << s5 << " converts into number " << k << "\n";
   assert(k == 0);

   x = double(s5);
   std::cout << "String " << s5 << " converts into number " << x << "\n";
   assert(x == 0.0);

   return 0;
}

