/*******************************************************
 *  Unit test for the SuperString class
 *
 * test contrustor and assignment of SuperSting objects
 ******************************************************
 *
 */

#include "String.h"
#include <assert.h>

int main()
{
   // Default contructor: empty string
   SuperString s0;

   std::cout << "The default contructor makes an empty superstring.\n";
   assert(~s0 == 0);

   String s1("abc");
   SuperString ss1(s1);

   std::cout << "Contructor from a String makes a superstring with 1 element.\n";
   assert(~ss1 == 1);

   SuperString ss2(4);

   std::cout << "Contructor with an integer argument makes a superstring with n elements.\n";
   assert(~ss2 == 4);

   // The copy contructor

   SuperString ss3(ss2);

   std::cout << "The copy contructor makes a bitwise copy.\n";
   assert(~ss3 == 4);

   //  Assignment to a SuperSting with n elements should remove the old elements.

   return 0;

   // A string from a literal string
   String s2("abc");

   std::cout << "A string from a literal string \"abc\": \"" << s2 << "\"\n";
   assert(~s2 == 3);

   // The copy constructor
   String s3(s2);

   std::cout << "A string copied from the previous string \"abc\": \"" << s3 << "\"\n";
   assert(~s3 == 3);

   // Assign a single character
   String s4;
   s4 = 'q';
   std::cout << "A string assigned a single charater 'q': \"" << s4 << "\"\n";
   assert(~s4 == 1);

   // Initialized with a single character
   String s5 = 'r';

   std::cout << "A string initialized with a single charater 'r': \"" << s5 << "\"\n";
   assert(~s5 == 1);

   // Assign a literal string
   String s6;
   s6 = "ijk";
   std::cout << "A string assigned a literal string \"ijk\": \"" << s6 << "\"\n";
   assert(~s6 == 3);

   // Initialized a literal string
   String s7 = "lmn";
   
   std::cout << "A string initialized with a literal string \"lmn\": \"" << s7 << "\"\n";
   assert(~s7 == 3);

   // Assign a String object
   String s8;
   s8 = s6;
   std::cout << "A string assigned a String object \"ijk\": \"" << s8 << "\"\n";
   assert(~s8 == 3);

   // Initialized a String object
   String s9 = s7;
   
   std::cout << "A string initialized with a String object \"lmn\": \"" << s9 << "\"\n";
   assert(~s9 == 3);

   return 0;
}

