/*******************************************************
 *  Unit test for the xml_element class
 *
 * test xml attributes access
 ******************************************************
 *
 */

#include "xml.h"
#include <assert.h>

int main()
{
   xml    doc;

   const char xml_file[] = "xml_test01.xml";

   std::cout << "Reading XML file " << xml_file << "\n";

   doc.ParseFile("xml_test01.xml");

   xml_element root_node(doc);

   std::cout << "Root element is " << root_node.name() << "\n";
   std::cout << "Root node type is " << root_node.type() << "\n";
   assert(root_node.name() == "doc");

   //std::vector<xml_element> book;
   xml_element book;
   std::map<String, String> book_attrs;

   book = root_node["book"][0];
   book_attrs = book.attributes();

   std::cout << book_attrs.size() << " attributes in element book.\n";
   std::cout << "Attribute id = " << book_attrs["id"] << "\n";
   assert(book_attrs["id"] == "toplevel");

   std::cout << "Attribute layout = " << book.attribute("layout") << "\n";
   assert(book.attribute("layout") == "A4");

   return 0;
}

